#NoTrayIcon



#include <isnautoitstudio_plugin.au3>

#include <GUIConstantsEx.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <Array.au3>
#include <File.au3>
#include <GuiListView.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>


Opt("GuiCoordMode", 0)
Opt("GuiOnEventMode", 1)
Opt("TrayIconHide", 1)
Opt("GUIResizeMode", 802)
Opt("GUICloseOnESC", 0)



Global $Mailslot_Handle = _ISNPlugin_erstelle_Mailslot() ;Erstellt fr das Plugin einen Mailslot wodurch das Plugin mit dem ISN komunizieren kann.

Global Const $sScriptName = _ISNPlugin_Get_langstring(1)

Global $aFilesFound = ""
Global $sSearchFolder = ""
Global $sSearchFilter = "au3"
Global $sSearchTerm = ""
Global $Sci_Handle
Global $aListViewEntryDetails[2][2]
Global $bList1Aktiv = -1

_GuiCreate()

If _ISNPlugin_Warte_auf_ISN_und_initialisiere_Kommunikation($Mailslot_Handle, $hGui) = 0 Then
	;Wichtig! Dadurch wird der Kommunikationsaufbau	abgeschlossen!
	MsgBox(16, "Error", "Dieses Programm ist Teil des ISN AutoIt Studios und kann nicht alleine gestartet werden!")
	Exit
EndIf

AdlibRegister("_Mailslot_abhoeren", 10) ;Registriere abhrfunktion fr den Mailslot

Sleep(500)

;~ Global $sScriptIniPath = $ISN_AutoIt_Studio_Projektpfad & "\" & $sScriptName & ".ini"


;~ _IniReadAll()

$sSearchFolder = $ISN_AutoIt_Studio_Projektpfad
_StatusBarSet($ISN_AutoIt_Studio_Projektpfad)
GUICtrlSetData($cLabel1, $ISN_AutoIt_Studio_Projektpfad & "\"); Ordner Pfad setzen, Standardmig der des projekts

Sleep(500); Timer to focus Edit properly
GUISetState(@SW_SHOWNORMAL, $hGui)
GUICtrlSetState($cEdit2, $GUI_FOCUS)

While 1
	Sleep(100)
WEnd


; ################################################################################################

Func _SelectFile()
;~ 	Local $beginChar = 1
;~ 	Local $endChar = $beginChar + StringLen($sSearchTerm)
	Local $s = GuiCtrlRead(GUICtrlRead($cList1))
	Local $s2 = GuiCtrlRead(GUICtrlRead($cList2))
	If $s = -1 Then Return
	If $s2 = -1 Then Return
	
	Local $i1 = StringMid($s,StringInStr($s,"|")+1,StringInStr($s,"|",0,2)-StringInStr($s,"|")-1)
	Local $i2 = StringLeft($s2,StringInStr($s2,"|")-1)
	
	Local $file = $sSearchFolder & StringLeft($s,StringInStr($s,"|")-1)
	Local $line = $i2
	
	_ISNPlugin_Starte_Funktion_im_ISN("Try_to_opten_file", $file)
	_ISNPlugin_Get_Variable("$Sci_Handle", "$SCE_EDITOR[_GUICtrlTab_GetCurFocus($hTab)]", $Mailslot_Handle)
	If $Sci_Handle <> "" Then
		_ISNPlugin_Starte_Funktion_im_ISN("Sci_SetCurrentLine", $Sci_Handle, $line)
;~ 		_ISNPlugin_Starte_Funktion_im_ISN("Sci_SetSelection",$Sci_Handle,$beginChar,$endChar)
	EndIf
EndFunc   ;==>_SelectFile

Func _SelectFolder()
	Local $f = FileSelectFolder("ffne Order....", Default, 2, -1, $hGui)
	If @error Or $f = "" Or FileExists($f) = 0 Then Return
	GUICtrlSetData($cLabel1, $f & "\")
	$sSearchFolder = $f
EndFunc   ;==>_SelectFolder

Func _SelectItemDetails()
	_GUICtrlListView_DeleteAllItems($cList2)
	Local $i = _GUICtrlListView_GetSelectionMark($cList1); Hot Item Index
	If $i = -1 Then $i = 0
	Local $s = $aListViewEntryDetails[$i][0]
	Local $s2 = $aListViewEntryDetails[$i][1]
	Opt("GUIDataSeparatorChar","%|%")
	Local $a = StringSplit($s,"%|%",1+2)
	Local $a2 = StringSplit($s2,"%|%",1+2)
	For $n=0 To UBound($a)-1 Step 1
		Local $s3 = $a2[$n] & "%" & $a[$n]
		GUICtrlCreateListViewItem($s3,$cList2)
		GUICtrlSetOnEvent(-1,"_GuiSetButtonOpenEntry")
	Next
	_GUICtrlListView_SetColumnWidth($cList2, 1, $LVSCW_AUTOSIZE)
	GUICtrlSetState($cList2, $GUI_FOCUS)
	_GUICtrlListView_SetItemSelected($cList2,0)
	Opt("GUIDataSeparatorChar","|")
EndFunc

Func _SearchFolder()
	_GUICtrlListView_DeleteAllItems($cList1)
	_GUICtrlListView_DeleteAllItems($cList2)
	Dim $aListViewEntryDetails[2][2]
	$sSearchFolder = GUICtrlRead($cLabel1)
	If $sSearchFolder = "" Or FileExists($sSearchFolder) = 0 Then
		GUICtrlSetState($cEdit2, $GUI_FOCUS)
		Return
	EndIf
	Local $filter = GUICtrlRead($cEdit1)
	If $filter = "" Then
		GUICtrlSetState($cEdit2, $GUI_FOCUS)
		Return
	EndIf
	$sSearchFilter = $filter
	If StringLeft($filter, 1) <> "*." Then $filter = "*." & $filter
	Local $search = GUICtrlRead($cEdit2)
	If $search = "" Then
		GUICtrlSetState($cEdit2, $GUI_FOCUS)
		Return
	EndIf
	$sSearchTerm = $search
	_StatusBarSet(_ISNPlugin_Get_langstring(2) & @TAB & _ISNPlugin_Get_langstring(3) & $filter)
	
	ProgressOn("", _ISNPlugin_Get_langstring(4), _ISNPlugin_Get_langstring(5), Default, Default, 1 + 16)
	
	$aFilesFound = _FileListToArrayEx($sSearchFolder, $filter, 1 + 4 + 8)
	_ArrayDelete($aFilesFound, 0)
	ProgressSet(50, _ISNPlugin_Get_langstring(6))
	_StatusBarSet(_ISNPlugin_Get_langstring(7) & UBound($aFilesFound) &  _ISNPlugin_Get_langstring(8) & $filter & _ISNPlugin_Get_langstring(9))
	
	Local $a, $index, $i2 = 0, $count,$a2
	For $i = 0 To UBound($aFilesFound) - 1 Step 1
		_FileReadToArray($aFilesFound[$i], $a)
		$a2 = _ArrayFindAll($a,$search,0,0,0,1)
		If @error Then ContinueLoop
		$index = $a2[0]
		$count = UBound($a2)
		If $index <> -1 Then
			If UBound($aListViewEntryDetails)-1 < $i2 Then ReDim $aListViewEntryDetails[$i2+1][2]
			For $n=0 To UBound($a2)-1 Step 1
				$aListViewEntryDetails[$i2][0] &= StringStripCR($a[$a2[$n]]) & "%|%"
				$aListViewEntryDetails[$i2][1] &= $a2[$n] & "%|%"
			Next
			$aListViewEntryDetails[$i2][0] = StringTrimRight($aListViewEntryDetails[$i2][0],3)
			$aListViewEntryDetails[$i2][1] = StringTrimRight($aListViewEntryDetails[$i2][1],3)
			$i2 += 1
			GUICtrlCreateListViewItem(StringReplace($aFilesFound[$i], $sSearchFolder, "") & "|" & $index & "|" & $count, $cList1)
			GUICtrlSetOnEvent(-1,"_SelectItemDetails")
		EndIf
	Next
	_StatusBarSet(_ISNPlugin_Get_langstring(10) & $i2 & _ISNPlugin_Get_langstring(11) & $search & _ISNPlugin_Get_langstring(12))
	ProgressSet(75, _ISNPlugin_Get_langstring(13))
	_GUICtrlListView_SetColumnWidth($cList1, 0, $LVSCW_AUTOSIZE)
	GUICtrlSetState($cList1, $GUI_FOCUS)
	GUICtrlSetState($cButton4,$GUI_DEFBUTTON)
	_GUICtrlListView_SetItemSelected($cList1,0)
	ProgressOff()
	_SelectItemDetails()
EndFunc   ;==>_SearchFolder

Func _StatusBarSet($text)
	GUICtrlSetData($cEdit0, $text & @CRLF & @CRLF & GUICtrlRead($cEdit0))
EndFunc   ;==>_StatusBarSet


Func _GuiCreate()
	Opt("GuiOnEventMode", 1)
	
	Global $sGuiName1 = $sScriptName
	Global $hGui = GUICreate($sGuiName1, 700, 500, Default, Default, $WS_POPUP, $WS_EX_CLIENTEDGE + $WS_EX_TOOLWINDOW)
	GUIRegisterMsg($WM_NOTIFY, "_WM_NOTIFY")
	GUIRegisterMsg($WM_COMMAND, "_WM_COMMAND"); im Programmstart hinterlegt
	
	GUISetCoord(15, 20)
	Global $cLabel1 = GUICtrlCreateLabel($sSearchFolder, 0, 0, 500, 20)
	Global $cLabel2 = GUICtrlCreateLabel(_ISNPlugin_Get_langstring(14), 0, 45, 300, 20)
	Global $cEdit1 = GUICtrlCreateEdit($sSearchFilter, 310, 0, 100, 0, $ES_AUTOVSCROLL)
	
	GUISetCoord(15, 100)
	Global $cLabel3 = GUICtrlCreateLabel(_ISNPlugin_Get_langstring(15), 0, 0, 200, 20)
	Global $cEdit2 = GUICtrlCreateEdit($sSearchTerm, 210, 0, 200, 0, $ES_AUTOVSCROLL)
	
	GUISetCoord(430, 20)
	Global $cButton1 = GUICtrlCreateButton(_ISNPlugin_Get_langstring(16), 0, 0, 120, 30); Ordnerpfad ffnen
	GUICtrlSetOnEvent(-1, "_SelectFolder")
	Global $cButton2 = GUICtrlCreateButton(_ISNPlugin_Get_langstring(17), 0, 35, 0, 0, $BS_DEFPUSHBUTTON); durchsuche Ordner
	GUICtrlSetOnEvent(-1, "_SearchFolder")
	
	GUISetCoord(560,20)
	Global $cButton3 = GuiCtrlCreateButton(_ISNPlugin_Get_langstring(18),0,0,0,0)
	GUICtrlSetOnEvent(-1,"_ScriptExit")
	Global $cButton4 = GUICtrlCreateButton(_ISNPlugin_Get_langstring(19),0,35,0,0)
	GUICtrlSetOnEvent(-1,"_SelectFile")
	
	GUISetCoord(15, 140)
	Global $cList1 = GUICtrlCreateListView(_ISNPlugin_Get_langstring(20), 0, 0, 645, 160,$LVS_SHOWSELALWAYS + $LVS_SINGLESEL + $LVS_NOSORTHEADER)
	
	GUISetCoord(15,310)
	Global $cList2 = GUICtrlCreateListView(_ISNPlugin_Get_langstring(21),0,0,645,160,$LVS_SHOWSELALWAYS + $LVS_SINGLESEL + $LVS_NOSORTHEADER)
	
	GUISetCoord(15, 480)
	Global $cEdit0 = GUICtrlCreateEdit("", 0, 0, 645, 80, $ES_READONLY + $WS_VSCROLL)
	
	GUISwitch($hGui)
	
	GUICtrlSetState($cEdit2, $GUI_FOCUS)
	
	GUISetOnEvent($GUI_EVENT_CLOSE, "_ScriptExit")
	
	Local $AccelKeys[1][2] = [["^w", $cButton3]]
	GUISetAccelerators($AccelKeys,$hGui)
	
EndFunc   ;==>_GuiCreate


Func _Mailslot_abhoeren()
	Local $Gelesene_Nachricht = ""
	If _ISNPlugin_pruefe_auf_neue_Nachrichten($Mailslot_Handle) <> 0 And $ISN_Plugin_Warte_auf_Nachricht = 0 Then
		Local $Gelesene_Nachricht = _ISNPlugin_Nachricht_lesen($Mailslot_Handle)
		If $Gelesene_Nachricht <> "" Then
			If _ISNPlugin_bekannte_Nachrichten_verarbeiten($Gelesene_Nachricht) = False Then ;Wenn _ISNPlugin_bekannte_Nachrichten_verarbeiten false ergibt prfe ob es sich um einen Benutzerbefehl handelt
				Switch _Pluginstring_get_element($Gelesene_Nachricht, 1)

					Case "save"
						;Speicherfunktion hier

					Case "exit"
						;Exit funktion hier
;~ 						$sSearchFilter = GUICtrlRead($cEdit1)
;~ 						$sSearchFolder = GUICtrlRead($cLabel1)
;~ 						$sSearchTerm = GUICtrlRead($cEdit2)
;~ 						_IniWriteAll()
						Exit
						
					Case "checkchanges"
						;Funktion fr nderungsprfung vor dem Beenden hier
						;Falls nicht verwendet bitte hier die Befehle "_ISNPlugin_Nachricht_senden("checkchangeswait")" & "_ISNPlugin_Nachricht_senden("changesok")" einfgen!
						;(Dadurch wartet das ISN nicht auf einen nderungscheck und beendet das Plugin schneller)
						_ISNPlugin_Nachricht_senden("checkchangeswait")
						_ISNPlugin_Nachricht_senden("changesok")
						
					Case "resize"
						;Funktion zum Aktualisieren der Fenstergre hier
				EndSwitch
			EndIf
		EndIf
	EndIf
EndFunc   ;==>_Mailslot_abhoeren

Func _ScriptExit()
;~ 	$sSearchFilter = GUICtrlRead($cEdit1)
;~ 	$sSearchFolder = GuiCtrlRead($cLabel1)
;~ 	$sSearchTerm = GuiCtrlRead($cEdit2)
;~ 	_IniWriteAll()
_ISNPlugin_Execute_im_ISN("try_to_Close_Tab(_GUICtrlTab_GetCurFocus($hTab))") ;Plugin Beenden lassen
EndFunc   ;==>_ScriptExit

;~ Func _IniReadAll()
;~ 	If FileExists($sScriptIniPath) = 0 Then Return
;~ 	$sSearchFolder = IniRead($sScriptIniPath, "General", "SearchFolder", $sSearchFolder)
;~ 	$sSearchFilter = IniRead($sScriptIniPath, "General", "SearchFilter", $sSearchFilter)
;~ 	$sSearchTerm = IniRead($sScriptIniPath, "General", "SearchTerm", $sSearchTerm)
;~ EndFunc   ;==>_IniReadAll

;~ Func _IniWriteAll()
;~ 	If FileExists($sScriptIniPath) = 0 Then FileClose(FileOpen($sScriptIniPath))
;~ 	IniWrite($sScriptIniPath, "General", "SearchFolder", $sSearchFolder)
;~ 	IniWrite($sScriptIniPath, "General", "SearchFilter", $sSearchFilter)
;~ 	IniWrite($sScriptIniPath, "General", "SearchTerm", $sSearchTerm)
;~ EndFunc   ;==>_IniWriteAll


; #UDF# =======================================================================================================================
; Title .........: File List To Array
; AutoIt Version : 3.3.8.1
; Language ......: English
; Description ...: Lists files and\or folders in a specified path (Similar to using Dir with the /B Switch)
; Author(s) .....: DXRW4E
; Notes .........:
; ===============================================================================================================================

; #CURRENT# =====================================================================================================================
;~ _FileListToArrayEx
; ===============================================================================================================================

; #FUNCTION# =======================================================================================================================================================
; Name...........: _FileListToArrayEx
; Description ...: Lists files and\or folders in a specified path (Similar to using Dir with the /B Switch)
; Syntax.........: _FileListToArrayEx($sPath[, $sFilter = "*"[, $iFlag = 0]])
; Parameters ....: $sPath   - Path to generate filelist for.
;                 $sFilter - Optional the filter to use, default is *. (Multiple filter groups such as "All "*.png|*.jpg|*.bmp") Search the Autoit3 helpfile for the word "WildCards" For details.
;                 $iFlag   - Optional: specifies whether to return files folders or both Or Full Path (add the flags together for multiple operations):
;                 |$iFlag = 0 (Default) Return both files and folders
;                 |$iFlag = 1 Return files only
;                 |$iFlag = 2 Return Folders only
;                 |$iFlag = 4 Search SubDirectory
;                 |$iFlag = 8 Return Full Path
;                 |$iFlag = 16 $sFilter do Case-Sensitive matching (By Default $sFilter do Case-Insensitive matching)
;                 |$iFlag = 32 Disable the return the count in the first element - effectively makes the array 0-based (must use UBound() to get the size in this case).
;                   By Default the first element ($array[0]) contains the number of file found, the remaining elements ($array[1], $array[2], etc.)
;                 |$iFlag = 64 $sFilter is REGEXP Mod, See Pattern Parameters in StringRegExp (Can not be combined with flag 16)
;                 |$iFlag = 128 Return Backslash at the beginning of the file name, example Return "\Filename1.xxx" (Can not be combined with flag 8)
; Return values .: Failure - @Error
;                 |1 = Path not found or invalid
;                 |2 = Invalid $sFilter
;                 |3 = No File(s) Found
; Author ........: DXRW4E
; Modified.......:
; Remarks .......: The array returned is one-dimensional and is made up as follows:
;                               $array[0] = Number of Files\Folders returned
;                               $array[1] = 1st File\Folder
;                               $array[2] = 2nd File\Folder
;                               $array[3] = 3rd File\Folder
;                               $array[n] = nth File\Folder
; Related .......:
; Link ..........:
; Example .......: Yes
; Note ..........: Special Thanks to SolidSnake & Tlem
; ==================================================================================================================================================================
Func _FileListToArrayEx($sPath, $sFilter = "*", $iFlag = 0)
	$sPath = StringRegExpReplace($sPath & "\", "(?!\A)[\\/]+\h*", "\\")
	If Not FileExists($sPath) Then Return SetError(1, 1, "")
	If StringRegExp($sFilter, StringReplace('^\s*$|\v|[\\/:><"]|^\||\|\||\|$', "[" & Chr(BitAND($iFlag, 64) + 28) & '\/:><"]|^\||\|\||\|$', "\\\\")) Then Return SetError(2, 2, "")
	Local $hSearch, $sFile, $sFileList, $sSubDir = BitAND($iFlag, 4), $sDelim = "|", $sDirFilter = StringReplace($sFilter, "*", "")
	$hSearch = FileFindFirstFile($sPath & "*")
	If @error Then Return SetError(3, 3, "")
	Local $hWSearch = $hSearch, $hWSTMP, $SearchWD, $Extended, $iFlags = StringReplace(BitAND($iFlag, 1) + BitAND($iFlag, 2), "3", "0")
	If BitAND($iFlag, 8) Then $sDelim &= $sPath
	If BitAND($iFlag, 128) Then $sDelim = "|\"
	If Not BitAND($iFlag, 64) Then $sFilter = StringRegExpReplace(BitAND($iFlag, 16) & "(?i)(", "16\(\?\i\)|\d+", "") & StringRegExpReplace(StringRegExpReplace(StringRegExpReplace(StringRegExpReplace($sFilter, "[^*?|]+", "\\Q$0\\E"), "\\E(?=\||$)", "$0\$"), "(?<=^|\|)\\Q", "^$0"), "\*+", ".*") & ")"
	While 1
		$sFile = FileFindNextFile($hWSearch)
		If @error Then
			If $hWSearch = $hSearch Then ExitLoop
			FileClose($hWSearch)
			$hWSearch -= 1
			$SearchWD = StringLeft($SearchWD, StringInStr($SearchWD, "\", 1, -2))
		ElseIf $sSubDir Then
			$Extended = @extended
			If ($iFlags + $Extended <> 2) Then
				If $sDirFilter Then
					If StringRegExp($sFile, $sFilter) Then $sFileList &= $sDelim & $SearchWD & $sFile
				Else
					$sFileList &= $sDelim & $SearchWD & $sFile
				EndIf
			EndIf
			If Not $Extended Then ContinueLoop
			$hWSTMP = FileFindFirstFile($sPath & $SearchWD & $sFile & "\*")
			If $hWSTMP = -1 Then ContinueLoop
			$hWSearch = $hWSTMP
			$SearchWD &= $sFile & "\"
		Else
			If ($iFlags + @extended = 2) Or StringRegExp($sFile, $sFilter) = 0 Then ContinueLoop
			$sFileList &= $sDelim & $sFile
		EndIf
	WEnd
	FileClose($hSearch)
	If Not $sFileList Then Return SetError(3, 3, "")
	Return StringSplit(StringTrimLeft($sFileList, 1), "|", StringReplace(BitAND($iFlag, 32), "32", 2))
EndFunc   ;==>_FileListToArrayEx

Func _GuiSetButtonOpenEntry()
	GUICtrlSetState($cButton4, $GUI_DEFBUTTON)
EndFunc

Func _WM_Command($hWnd, $Msg, $wParam, $lParam)
	If BitAND($wParam, 0x0000FFFF) = $cEdit2 Then GUICtrlSetState($cButton2, $GUI_DEFBUTTON)
	Return $GUI_RUNDEFMSG
EndFunc


Func _WM_NOTIFY($hWnd, $Msg, $wParam, $lParam)
	Local $tagNMHDR, $event, $hwndFrom, $code
	$tagNMHDR = DllStructCreate("int;int;int", $lParam)
	If @error Then Return
	$event = DllStructGetData($tagNMHDR, 3); Checkt wie das EVENT aussieht
	Switch $wParam
	Case $cEdit2
		_StatusBarSet("Test" & @LF)
;~ 		If $event = $NM_DBLCLK Then;.. Wenn es ein DoppelKlick war
			; Hier kommt hin was er machen soll:
;~ 			_SelectFile(BitAND($wParam, 0x0000FFFF))
;~ 			_SelectFile()
;~ 		ElseIf $event = $NM_CLICK Then; Wenn es ein einfacher Klick war
;~ 			_SelectItemDetails(BitAnd($wParam,0x0000FFFF))
;~ 		EndIf
	Case $cList2
		If $event = $NM_DBLCLK Then;.. Wenn es ein DoppelKlick war
			; Hier kommt hin was er machen soll:
			_SelectFile()
		EndIf
	EndSwitch
	$tagNMHDR = 0
	$event = 0
	$lParam = 0
EndFunc   ;==>_WM_NOTIFY


